# _hw.tcl file for mSGDMA
package require -exact qsys 14.0

# module properties
set_module_property NAME {mSGDMA_export}
set_module_property DISPLAY_NAME {mSGDMA_export_display}

# default module properties
set_module_property VERSION {1.0}
set_module_property GROUP {default group}
set_module_property DESCRIPTION {default description}
set_module_property AUTHOR {author}

set_module_property COMPOSITION_CALLBACK compose
set_module_property opaque_address_map false

proc compose { } {
    # Instances and instance parameters
    # (disabled instances are intentionally culled)
    add_instance clk clock_source 17.0
    set_instance_parameter_value clk {clockFrequency} {100000000.0}
    set_instance_parameter_value clk {clockFrequencyKnown} {1}
    set_instance_parameter_value clk {resetSynchronousEdges} {NONE}

    add_instance dispatcher_read modular_sgdma_dispatcher 17.0
    set_instance_parameter_value dispatcher_read {BURST_ENABLE} {0}
    set_instance_parameter_value dispatcher_read {BURST_WRAPPING_SUPPORT} {0}
    set_instance_parameter_value dispatcher_read {CSR_ADDRESS_WIDTH} {3}
    set_instance_parameter_value dispatcher_read {DATA_FIFO_DEPTH} {32}
    set_instance_parameter_value dispatcher_read {DATA_WIDTH} {32}
    set_instance_parameter_value dispatcher_read {DESCRIPTOR_FIFO_DEPTH} {1024}
    set_instance_parameter_value dispatcher_read {ENHANCED_FEATURES} {0}
    set_instance_parameter_value dispatcher_read {GUI_RESPONSE_PORT} {0}
    set_instance_parameter_value dispatcher_read {MAX_BURST_COUNT} {2}
    set_instance_parameter_value dispatcher_read {MAX_BYTE} {1024}
    set_instance_parameter_value dispatcher_read {MAX_STRIDE} {1}
    set_instance_parameter_value dispatcher_read {MODE} {1}
    set_instance_parameter_value dispatcher_read {PREFETCHER_USE_CASE} {0}
    set_instance_parameter_value dispatcher_read {PROGRAMMABLE_BURST_ENABLE} {0}
    set_instance_parameter_value dispatcher_read {STRIDE_ENABLE} {0}
    set_instance_parameter_value dispatcher_read {TRANSFER_TYPE} {Aligned Accesses}

    add_instance dispatcher_write modular_sgdma_dispatcher 17.0
    set_instance_parameter_value dispatcher_write {BURST_ENABLE} {0}
    set_instance_parameter_value dispatcher_write {BURST_WRAPPING_SUPPORT} {0}
    set_instance_parameter_value dispatcher_write {CSR_ADDRESS_WIDTH} {3}
    set_instance_parameter_value dispatcher_write {DATA_FIFO_DEPTH} {32}
    set_instance_parameter_value dispatcher_write {DATA_WIDTH} {32}
    set_instance_parameter_value dispatcher_write {DESCRIPTOR_FIFO_DEPTH} {1024}
    set_instance_parameter_value dispatcher_write {ENHANCED_FEATURES} {0}
    set_instance_parameter_value dispatcher_write {GUI_RESPONSE_PORT} {2}
    set_instance_parameter_value dispatcher_write {MAX_BURST_COUNT} {2}
    set_instance_parameter_value dispatcher_write {MAX_BYTE} {1024}
    set_instance_parameter_value dispatcher_write {MAX_STRIDE} {1}
    set_instance_parameter_value dispatcher_write {MODE} {2}
    set_instance_parameter_value dispatcher_write {PREFETCHER_USE_CASE} {0}
    set_instance_parameter_value dispatcher_write {PROGRAMMABLE_BURST_ENABLE} {0}
    set_instance_parameter_value dispatcher_write {STRIDE_ENABLE} {0}
    set_instance_parameter_value dispatcher_write {TRANSFER_TYPE} {Aligned Accesses}

    add_instance dma_read_master dma_read_master 17.0
    set_instance_parameter_value dma_read_master {BURST_ENABLE} {1}
    set_instance_parameter_value dma_read_master {CHANNEL_ENABLE} {0}
    set_instance_parameter_value dma_read_master {CHANNEL_WIDTH} {8}
    set_instance_parameter_value dma_read_master {DATA_WIDTH} {32}
    set_instance_parameter_value dma_read_master {ERROR_ENABLE} {0}
    set_instance_parameter_value dma_read_master {ERROR_WIDTH} {8}
    set_instance_parameter_value dma_read_master {FIFO_DEPTH} {1024}
    set_instance_parameter_value dma_read_master {FIFO_SPEED_OPTIMIZATION} {1}
    set_instance_parameter_value dma_read_master {FIX_ADDRESS_WIDTH} {32}
    set_instance_parameter_value dma_read_master {GUI_BURST_WRAPPING_SUPPORT} {1}
    set_instance_parameter_value dma_read_master {GUI_MAX_BURST_COUNT} {8}
    set_instance_parameter_value dma_read_master {GUI_PROGRAMMABLE_BURST_ENABLE} {0}
    set_instance_parameter_value dma_read_master {GUI_STRIDE_WIDTH} {1}
    set_instance_parameter_value dma_read_master {LENGTH_WIDTH} {24}
    set_instance_parameter_value dma_read_master {PACKET_ENABLE} {0}
    set_instance_parameter_value dma_read_master {STRIDE_ENABLE} {0}
    set_instance_parameter_value dma_read_master {TRANSFER_TYPE} {Full Word Accesses Only}
    set_instance_parameter_value dma_read_master {USE_FIX_ADDRESS_WIDTH} {0}

    add_instance dma_write_master dma_write_master 17.0
    set_instance_parameter_value dma_write_master {BURST_ENABLE} {1}
    set_instance_parameter_value dma_write_master {DATA_WIDTH} {32}
    set_instance_parameter_value dma_write_master {ERROR_ENABLE} {0}
    set_instance_parameter_value dma_write_master {ERROR_WIDTH} {8}
    set_instance_parameter_value dma_write_master {FIFO_DEPTH} {1024}
    set_instance_parameter_value dma_write_master {FIFO_SPEED_OPTIMIZATION} {1}
    set_instance_parameter_value dma_write_master {FIX_ADDRESS_WIDTH} {32}
    set_instance_parameter_value dma_write_master {GUI_BURST_WRAPPING_SUPPORT} {1}
    set_instance_parameter_value dma_write_master {GUI_MAX_BURST_COUNT} {8}
    set_instance_parameter_value dma_write_master {GUI_PROGRAMMABLE_BURST_ENABLE} {0}
    set_instance_parameter_value dma_write_master {GUI_STRIDE_WIDTH} {1}
    set_instance_parameter_value dma_write_master {LENGTH_WIDTH} {24}
    set_instance_parameter_value dma_write_master {PACKET_ENABLE} {0}
    set_instance_parameter_value dma_write_master {STRIDE_ENABLE} {0}
    set_instance_parameter_value dma_write_master {TRANSFER_TYPE} {Full Word Accesses Only}
    set_instance_parameter_value dma_write_master {USE_FIX_ADDRESS_WIDTH} {0}

    add_instance freq_counter_0 freq_counter 1.0
    set_instance_parameter_value freq_counter_0 {DIV} {1}
    set_instance_parameter_value freq_counter_0 {SYSTEM_CLK_FREQ_PICO_SEC} {10000}

    add_instance mm_bridge_slv altera_avalon_mm_bridge 17.0
    set_instance_parameter_value mm_bridge_slv {ADDRESS_UNITS} {SYMBOLS}
    set_instance_parameter_value mm_bridge_slv {ADDRESS_WIDTH} {20}
    set_instance_parameter_value mm_bridge_slv {DATA_WIDTH} {32}
    set_instance_parameter_value mm_bridge_slv {LINEWRAPBURSTS} {0}
    set_instance_parameter_value mm_bridge_slv {MAX_BURST_SIZE} {8}
    set_instance_parameter_value mm_bridge_slv {MAX_PENDING_RESPONSES} {16}
    set_instance_parameter_value mm_bridge_slv {PIPELINE_COMMAND} {1}
    set_instance_parameter_value mm_bridge_slv {PIPELINE_RESPONSE} {1}
    set_instance_parameter_value mm_bridge_slv {SYMBOL_WIDTH} {8}
    set_instance_parameter_value mm_bridge_slv {USE_AUTO_ADDRESS_WIDTH} {1}
    set_instance_parameter_value mm_bridge_slv {USE_RESPONSE} {0}

    add_instance prbs_pattern_checker prbs_pattern_checker 1.1
    set_instance_parameter_value prbs_pattern_checker {DATA_WIDTH} {32}
    set_instance_parameter_value prbs_pattern_checker {PRBS_WIDTH} {16}

    add_instance prbs_pattern_generator prbs_pattern_generator 1.1
    set_instance_parameter_value prbs_pattern_generator {DATA_WIDTH} {32}
    set_instance_parameter_value prbs_pattern_generator {PRBS_WIDTH} {16}

    add_instance timer_0 altera_avalon_timer 17.0
    set_instance_parameter_value timer_0 {alwaysRun} {0}
    set_instance_parameter_value timer_0 {counterSize} {32}
    set_instance_parameter_value timer_0 {fixedPeriod} {0}
    set_instance_parameter_value timer_0 {period} {1}
    set_instance_parameter_value timer_0 {periodUnits} {MSEC}
    set_instance_parameter_value timer_0 {resetOutput} {0}
    set_instance_parameter_value timer_0 {snapshot} {1}
    set_instance_parameter_value timer_0 {timeoutPulseOutput} {0}
    set_instance_parameter_value timer_0 {watchdogPulse} {2}

    add_instance timing_adapter timing_adapter 17.0
    set_instance_parameter_value timing_adapter {inBitsPerSymbol} {8}
    set_instance_parameter_value timing_adapter {inChannelWidth} {0}
    set_instance_parameter_value timing_adapter {inErrorDescriptor} {}
    set_instance_parameter_value timing_adapter {inErrorWidth} {0}
    set_instance_parameter_value timing_adapter {inMaxChannel} {0}
    set_instance_parameter_value timing_adapter {inReadyLatency} {1}
    set_instance_parameter_value timing_adapter {inSymbolsPerBeat} {4}
    set_instance_parameter_value timing_adapter {inUseEmpty} {0}
    set_instance_parameter_value timing_adapter {inUseEmptyPort} {AUTO}
    set_instance_parameter_value timing_adapter {inUsePackets} {0}
    set_instance_parameter_value timing_adapter {inUseReady} {1}
    set_instance_parameter_value timing_adapter {inUseValid} {1}
    set_instance_parameter_value timing_adapter {outReadyLatency} {0}
    set_instance_parameter_value timing_adapter {outUseReady} {1}
    set_instance_parameter_value timing_adapter {outUseValid} {1}

    # connections and connection parameters
    add_connection clk.clk dispatcher_read.clock clock

    add_connection clk.clk dispatcher_write.clock clock

    add_connection clk.clk dma_read_master.Clock clock

    add_connection clk.clk dma_write_master.Clock clock

    add_connection clk.clk freq_counter_0.clock clock

    add_connection clk.clk freq_counter_0.sample_clock clock

    add_connection clk.clk mm_bridge_slv.clk clock

    add_connection clk.clk prbs_pattern_checker.clock clock

    add_connection clk.clk prbs_pattern_generator.clock clock

    add_connection clk.clk timer_0.clk clock

    add_connection clk.clk timing_adapter.clk clock

    add_connection clk.clk_reset dispatcher_read.clock_reset reset

    add_connection clk.clk_reset dispatcher_write.clock_reset reset

    add_connection clk.clk_reset dma_read_master.Clock_reset reset

    add_connection clk.clk_reset dma_write_master.Clock_reset reset

    add_connection clk.clk_reset freq_counter_0.reset reset

    add_connection clk.clk_reset mm_bridge_slv.reset reset

    add_connection clk.clk_reset prbs_pattern_checker.reset reset

    add_connection clk.clk_reset prbs_pattern_generator.reset reset

    add_connection clk.clk_reset timer_0.reset reset

    add_connection clk.clk_reset timing_adapter.reset reset

    add_connection dispatcher_read.Read_Command_Source dma_read_master.Command_Sink avalon_streaming

    add_connection dispatcher_write.Write_Command_Source dma_write_master.Command_Sink avalon_streaming

    add_connection dma_read_master.Data_Source prbs_pattern_checker.st_pattern_input avalon_streaming

    add_connection dma_read_master.Response_Source dispatcher_read.Read_Response_Sink avalon_streaming

    add_connection dma_write_master.Response_Source dispatcher_write.Write_Response_Sink avalon_streaming

    add_connection mm_bridge_slv.m0 dispatcher_read.CSR avalon
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.CSR arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.CSR baseAddress {0x0080}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.CSR defaultConnection {0}

    add_connection mm_bridge_slv.m0 dispatcher_read.Descriptor_Slave avalon
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.Descriptor_Slave arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.Descriptor_Slave baseAddress {0x00b0}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_read.Descriptor_Slave defaultConnection {0}

    add_connection mm_bridge_slv.m0 dispatcher_write.CSR avalon
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.CSR arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.CSR baseAddress {0x0060}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.CSR defaultConnection {0}

    add_connection mm_bridge_slv.m0 dispatcher_write.Descriptor_Slave avalon
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.Descriptor_Slave arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.Descriptor_Slave baseAddress {0x00a0}
    set_connection_parameter_value mm_bridge_slv.m0/dispatcher_write.Descriptor_Slave defaultConnection {0}

    add_connection mm_bridge_slv.m0 freq_counter_0.csr avalon
    set_connection_parameter_value mm_bridge_slv.m0/freq_counter_0.csr arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/freq_counter_0.csr baseAddress {0x0140}
    set_connection_parameter_value mm_bridge_slv.m0/freq_counter_0.csr defaultConnection {0}

    add_connection mm_bridge_slv.m0 prbs_pattern_checker.csr avalon
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_checker.csr arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_checker.csr baseAddress {0x0000}
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_checker.csr defaultConnection {0}

    add_connection mm_bridge_slv.m0 prbs_pattern_generator.csr avalon
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_generator.csr arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_generator.csr baseAddress {0x0040}
    set_connection_parameter_value mm_bridge_slv.m0/prbs_pattern_generator.csr defaultConnection {0}

    add_connection mm_bridge_slv.m0 timer_0.s1 avalon
    set_connection_parameter_value mm_bridge_slv.m0/timer_0.s1 arbitrationPriority {1}
    set_connection_parameter_value mm_bridge_slv.m0/timer_0.s1 baseAddress {0x0100}
    set_connection_parameter_value mm_bridge_slv.m0/timer_0.s1 defaultConnection {0}

    add_connection prbs_pattern_generator.st_pattern_output timing_adapter.in avalon_streaming

    add_connection timing_adapter.out dma_write_master.Data_Sink avalon_streaming

    # exported interfaces
    add_interface clk clock sink
    set_interface_property clk EXPORT_OF clk.clk_in
    add_interface dispatcher_read_csr_irq interrupt sender
    set_interface_property dispatcher_read_csr_irq EXPORT_OF dispatcher_read.csr_irq
    add_interface dispatcher_write_csr_irq interrupt sender
    set_interface_property dispatcher_write_csr_irq EXPORT_OF dispatcher_write.csr_irq
    add_interface dma_read_master avalon master
    set_interface_property dma_read_master EXPORT_OF dma_read_master.Data_Read_Master
    add_interface dma_write_master avalon master
    set_interface_property dma_write_master EXPORT_OF dma_write_master.Data_Write_Master
    add_interface mm_bridge_slv avalon slave
    set_interface_property mm_bridge_slv EXPORT_OF mm_bridge_slv.s0
    add_interface reset reset sink
    set_interface_property reset EXPORT_OF clk.clk_in_reset

    # interconnect requirements
    set_interconnect_requirement {$system} {qsys_mm.clockCrossingAdapter} {HANDSHAKE}
    set_interconnect_requirement {$system} {qsys_mm.maxAdditionalLatency} {4}
}
